Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.io.input
Class XmlStreamReader

    java.lang.Object
      java.io.Reader
          org.apache.commons.io.input.XmlStreamReader

All Implemented Interfaces:
  Closeable, Readable

    public class XmlStreamReader

extends Reader

Character stream that handles all the necessary Voodo to figure out the charset encoding of the XML document within the stream.

IMPORTANT: This class is not related in any way to the org.xml.sax.XMLReader. This one IS a character stream.

All this has to be done without consuming characters from the stream, if not the XML parser will not recognized the document as a valid XML. This is not 100% true, but it's close enough (UTF-8 BOM is not handled by all parsers right now, XmlStreamReader handles it and things work in all parsers).

The XmlStreamReader class handles the charset encoding of XML documents in Files, raw streams and HTTP streams by offering a wide set of constructors.

By default the charset encoding detection is lenient, the constructor with the lenient flag can be used for an script (following HTTP MIME and XML specifications). All this is nicely explained by Mark Pilgrim in his blog, Determining the character encoding of a feed.

Originally developed for ROME under Apache License 2.0.

Since:
  Commons IO 2.0
Version:
  $Id: XmlStreamReader.java 1021884 2010-10-12 18:49:16Z ggregory $
Author:
  Alejandro Abdelnur
See Also:
  `XmlStreamWriter`

Field Summary
`static Pattern` | `ENCODING_PATTERN`

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`XmlStreamReader(File file)` Creates a Reader for a File.
`XmlStreamReader(InputStream is)` Creates a Reader for a raw InputStream.
`XmlStreamReader(InputStream is, boolean lenient)` Creates a Reader for a raw InputStream.
`XmlStreamReader(InputStream is, boolean lenient, String defaultEncoding)` Creates a Reader for a raw InputStream.
`XmlStreamReader(InputStream is, String httpContentType)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader(InputStream is, String httpContentType, boolean lenient)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader(InputStream is, String httpContentType, boolean lenient, String defaultEncoding)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader(URL url)` Creates a Reader using the InputStream of a URL.
`XmlStreamReader(URLConnection conn, String defaultEncoding)` Creates a Reader using the InputStream of a URLConnection.

Method Summary
`void` | `close()` Closes the XmlStreamReader stream.
`String` | `getDefaultEncoding()` Returns the default encoding to use if none is set in HTTP content-type, XML prolog and the rules based on content-type are not adequate.
`String` | `getEncoding()` Returns the charset encoding of the XmlStreamReader.
`int` | `read(char[] buf, int offset, int len)` Invokes the underlying reader's `read(char[], int, int)` method.

Methods inherited from class java.io.Reader
`mark, markSupported, read, read, read, ready, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ENCODING_PATTERN

    public static final Pattern ENCODING_PATTERN

Constructor Detail

### XmlStreamReader

    public XmlStreamReader(File file)
                    throws IOException

  Creates a Reader for a File.

  It looks for the UTF-8 BOM first, if none sniffs the XML prolog charset, if this is also missing defaults to UTF-8.

  It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

  Parameters:
    `file` - File to create a Reader from.
  Throws:
    `IOException` - thrown if there is a problem reading the file.

### XmlStreamReader

    public XmlStreamReader(InputStream is)
                    throws IOException

  Creates a Reader for a raw InputStream.

  It follows the same logic used for files.

  It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

  Parameters:
    `is` - InputStream to create a Reader from.
  Throws:
    `IOException` - thrown if there is a problem reading the stream.

### XmlStreamReader

    public XmlStreamReader(InputStream is,
                           boolean lenient)
                    throws IOException

  Creates a Reader for a raw InputStream.

  It follows the same logic used for files.

  If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

  If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

  Else if the XML prolog had a charset encoding that encoding is used.

  Else if the content type had a charset encoding that encoding is used.

  Else 'UTF-8' is used.

  If lenient detection is indicated an XmlStreamReaderException is never thrown.

  Parameters:
    `is` - InputStream to create a Reader from.
    `lenient` - indicates if the charset encoding detection should be relaxed.
  Throws:
    `IOException` - thrown if there is a problem reading the stream.
    `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

### XmlStreamReader

    public XmlStreamReader(InputStream is,
                           boolean lenient,
                           String defaultEncoding)
                    throws IOException

  Creates a Reader for a raw InputStream.

  It follows the same logic used for files.

  If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

  If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

  Else if the XML prolog had a charset encoding that encoding is used.

  Else if the content type had a charset encoding that encoding is used.

  Else 'UTF-8' is used.

  If lenient detection is indicated an XmlStreamReaderException is never thrown.

  Parameters:
    `is` - InputStream to create a Reader from.
    `lenient` - indicates if the charset encoding detection should be relaxed.
    `defaultEncoding` - The default encoding
  Throws:
    `IOException` - thrown if there is a problem reading the stream.
    `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

### XmlStreamReader

    public XmlStreamReader(URL url)
                    throws IOException

  Creates a Reader using the InputStream of a URL.

  If the URL is not of type HTTP and there is not 'content-type' header in the fetched data it uses the same logic used for Files.

  If the URL is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

  It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

  Parameters:
    `url` - URL to create a Reader from.
  Throws:
    `IOException` - thrown if there is a problem reading the stream of the URL.

### XmlStreamReader

    public XmlStreamReader(URLConnection conn,
                           String defaultEncoding)
                    throws IOException

  Creates a Reader using the InputStream of a URLConnection.

  If the URLConnection is not of type HttpURLConnection and there is not 'content-type' header in the fetched data it uses the same logic used for files.

  If the URLConnection is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

  It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

  Parameters:
    `conn` - URLConnection to create a Reader from.
    `defaultEncoding` - The default encoding
  Throws:
    `IOException` - thrown if there is a problem reading the stream of the URLConnection.

### XmlStreamReader

    public XmlStreamReader(InputStream is,
                           String httpContentType)
                    throws IOException

  Creates a Reader using an InputStream an the associated content-type header.

  First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

  It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

  Parameters:
    `is` - InputStream to create the reader from.
    `httpContentType` - content-type header to use for the resolution of the charset encoding.
  Throws:
    `IOException` - thrown if there is a problem reading the file.

### XmlStreamReader

    public XmlStreamReader(InputStream is,
                           String httpContentType,
                           boolean lenient,
                           String defaultEncoding)
                    throws IOException

  Creates a Reader using an InputStream an the associated content-type header. This constructor is lenient regarding the encoding detection.

  First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

  If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

  If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

  Else if the XML prolog had a charset encoding that encoding is used.

  Else if the content type had a charset encoding that encoding is used.

  Else 'UTF-8' is used.

  If lenient detection is indicated an XmlStreamReaderException is never thrown.

  Parameters:
    `is` - InputStream to create the reader from.
    `httpContentType` - content-type header to use for the resolution of the charset encoding.
    `lenient` - indicates if the charset encoding detection should be relaxed.
    `defaultEncoding` - The default encoding
  Throws:
    `IOException` - thrown if there is a problem reading the file.
    `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

### XmlStreamReader

    public XmlStreamReader(InputStream is,
                           String httpContentType,
                           boolean lenient)
                    throws IOException

  Creates a Reader using an InputStream an the associated content-type header. This constructor is lenient regarding the encoding detection.

  First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

  If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

  If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

  Else if the XML prolog had a charset encoding that encoding is used.

  Else if the content type had a charset encoding that encoding is used.

  Else 'UTF-8' is used.

  If lenient detection is indicated an XmlStreamReaderException is never thrown.

  Parameters:
    `is` - InputStream to create the reader from.
    `httpContentType` - content-type header to use for the resolution of the charset encoding.
    `lenient` - indicates if the charset encoding detection should be relaxed.
  Throws:
    `IOException` - thrown if there is a problem reading the file.
    `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

Method Detail

### getDefaultEncoding

    public String getDefaultEncoding()

  Returns the default encoding to use if none is set in HTTP content-type, XML prolog and the rules based on content-type are not adequate.

  If it is NULL the content-type based rules are used.

  Returns:
    the default encoding to use.

### getEncoding

    public String getEncoding()

  Returns the charset encoding of the XmlStreamReader.

  Returns:
    charset encoding.

### read

    public int read(char[] buf,
                    int offset,
                    int len)
             throws IOException

  Invokes the underlying reader's `read(char[], int, int)` method.

  Specified by:
    `read` in class `Reader`
  Parameters:
    `buf` - the buffer to read the characters into
    `offset` - The start offset
    `len` - The number of bytes to read
  Returns:
    the number of characters read or -1 if the end of stream
  Throws:
    `IOException` - if an I/O error occurs

### close

    public void close()
               throws IOException

  Closes the XmlStreamReader stream.

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in class `Reader`
  Throws:
    `IOException` - thrown if there was a problem closing the stream.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2010 The Apache Software Foundation. All Rights Reserved.